package xyz.joethei.studium.algodat.praktikum;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import xyz.joethei.studium.algodat.praktikum.blatt4.Heap;
import xyz.joethei.studium.algodat.praktikum.blatt4.HeapMain;

import static org.junit.jupiter.api.Assertions.assertEquals;

class HeapTest {

    private int[] n = new int[]{1, 3, 7, 15, 31, 63, 127, 255, 511, 1023, 2047, 4095, 8191, 16383, 32767, 65535};

    @Test
    void iterativ() {
        int[] res = new int[]{0, 2, 10, 34, 98, 258, 642, 1538, 3586, 8194, 18434, 40962, 90114, 196610, 425986, 917506};
        for (int i = 0; i < 15; i++) {
            assertEquals(res[i], HeapMain.getHeap(n[i]).getSwapCount());
        }
    }

    @Disabled
    @Test
    void geblockt() {
        int[] res = new int[]{};
        for (int i = 0; i < 15; i++) {
            int[] array = new int[i];
            for (int j = i; j > 0; j--) {
                array[j-1] = j;
            }
            Heap heap = new Heap(array);
            assertEquals(res[i], heap.getSwapCount());
        }
    }
}