package xyz.joethei.studium.algodat.praktikum.blatt2;

import org.jetbrains.annotations.NotNull;

import java.util.Iterator;

public class ArrayList<E> implements List<E> {

	private static final int MAXSIZE = 32;
	private int size;

	private E[] a;

	ArrayList() {
		size = 0;
		a = (E[]) new Object[MAXSIZE];
	}

	public boolean add(E e) {
		if (size < MAXSIZE) {
			a[size] = e;
			size++;
			return true;
		} else {
			return false;
		}

	}

	public E get(int index) {
		if (index < 0 || index >= size) {
			throw new IndexOutOfBoundsException();
		}

		return a[index];
	}

	public int size() {
		return size;
	}

	@Override
	public E remove(int index) {
		return null;
	}

	@Override
	public boolean remove(Object o) {
		return false;
	}

	@Override
	public int indexOf(E e) {
		return 0;
	}

	@NotNull
	public Iterator<E> iterator() {
		return new Iterator<E>() {
			int next = 0;
			int current;

			public boolean hasNext() {
				return next < size;
			}

			public E next() {
				current = next;
				if (next < size) {
					next++;
				}
				return a[current];
			}

			public void remove() {
				throw new UnsupportedOperationException();
			}
		};
	}

}
