package xyz.joethei.studium.algodat.praktikum.blatt2;

import java.util.Iterator;

public class Main {

	public static void main(String[] args) {

		int n = 10;
		if (args.length > 0) {
			n = Integer.parseInt(args[0]);
		}

		List<Integer> aList = new LinkedList<>();

		for (int i = 1; i <= n; i++) {
			aList.add(i * i);
		}

		/* Ausgabe der Integer-LinkedList aList */
		System.out.println("--- Integer-LinkedList aList ---");
		for (int i = 0; i < aList.size(); i++) {
			System.out.print(aList.get(i) + "  ");
		}
		System.out.println("\n");

		aList.remove(5);

		for (int i = 0; i < aList.size(); i++) {
			System.out.print(aList.get(i) + "  ");
		}
		System.out.println("\n");

		List<String> bList = new LinkedList<>();

		for (int i = 1; i <= n; i++) {
			bList.add(i + "^2 = " + i * i);
		}

		/* Ausgabe der String-LinkedList bList */
		System.out.println("--- String-LinkedList bList ---");
		for (String aBList : bList) {
			System.out.print(aBList + "  ");
		}
		System.out.println("\n");

		List<Integer> cList = new ArrayList<>();

		for (int i = 1; i <= n; i++) {
			cList.add(i * i);
		}

		/* Ausgabe der Integer-ArrayList cList */
		System.out.println("--- Integer-ArrayList cList ---");
		for (int i = 0; i < cList.size(); i++) {
			System.out.print(cList.get(i) + "  ");
		}
		System.out.println("\n");

		List<String> dList = new ArrayList<>();

		for (int i = 1; i <= n; i++) {
			dList.add(i + "^2 = " + i * i);
		}

		/* Ausgabe der String-ArrayList dList */
		System.out.println("--- String-ArrayList dList ---");
		for (String aDList : dList) {
			System.out.print(aDList + "  ");
		}
		System.out.println("\n");

		List<Integer> rList = new RingList<>();
		for (int i = 1; i <= n; i++) {
			rList.add(i * i);
		}

		/* Ausgabe der Integer-RingList rList */
		System.out.println("--- Integer-RingList rList ---");
		for (int i = 0; i < rList.size(); i++) {
			System.out.print(rList.get(i) + "  ");
		}
		System.out.println("\n");

		for(int i : rList) {
			System.out.print(i + " ");
		}
		System.out.println();

		Iterator<Integer> iter = rList.iterator();
		while(iter.hasNext()) {
			System.out.print(iter.next() + " ");
		}

		System.out.println();


	}
}
