package xyz.joethei.studium.algodat.vorlesung;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class DuplicatesList {

    private static void duplicateDetection(List list) {
        for (int i = 0; i < list.size(); i++) {
            for (int j = 0; j < list.size(); j++) {
                Object obj = list.get(j);
                if (list.indexOf(obj) != list.lastIndexOf(obj)) {
                    list.remove(obj);
                }
            }

        }
    }

    public static void main(String[] args) {
        List<Integer> list = new ArrayList<>();
        Random random = new Random();
        for (int i = 0; i < 10000; i++) {
            list.add(random.nextInt(10));
        }
        System.out.println(list);
        long time = System.currentTimeMillis();
        duplicateDetection(list);
        /*
        Stream Variant
        list = list.stream().distinct().collect(Collectors.toList());
         */
        System.out.println("time: " + (System.currentTimeMillis() - time));
        System.out.print(list);
    }
}